use config::Config;
use db::Database;

mod artist;
mod artwork;
mod comment;
pub mod config;
mod db;
mod error;
mod file;
pub mod routes;
mod ructe_poem;

pub type Result<T> = std::result::Result<T, error::Error>;

#[derive(Clone)]
pub struct Critch {
    db: Database,
    config: Config,
}

impl Critch {
    pub async fn new(config: Config) -> Self {
        let db = Database::new(config.database_connection()).await;

        Self { db, config }
    }
}

include!(concat!(env!("OUT_DIR"), "/templates.rs"));
